import Vue from "vue";
import Vuex from "vuex";
import { queryAllOrgan } from "@/views/message/api";
import { queryEmployeeOrgan } from "@/views/message/api";
Vue.use(Vuex);

const loadings = {};
const filterOrganId = [
  36, 39, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 52, 54, 55, 56,
];
export default new Vuex.Store({
  state: {
    branchs: [],
    allBranch: [],
    activeStudents: [], // 活动排课学生
    activeCourse: {}, //活动排课
  },
  mutations: {
    commit_branchs: (state, branchs) => {
      state.branchs = branchs;
    },
    commit_all_branch: (state, allBranch) => {
      state.allBranch = allBranch;
    },
    commit_set_active_students: (state, students) => {
      state.activeStudents = students;
    },
    commit_set_active_course: (state, course) => {
      state.activeCourse = course;
    },
  },
  actions: {
    async setBranchs({ commit, state }, force) {
      // console.log(state, state.branchs, force, loadings.commit_branchs, 'state')
      if (
        (!state.branchs.length || force === true) &&
        !loadings.commit_branchs
      ) {
        loadings.commit_branchs = await queryEmployeeOrgan();
        try {
          const res = await loadings.commit_branchs;
          commit("commit_branchs", res.data);
        } catch (error) {
          //
        }
        loadings.commit_branchs = false;
      }
    },
    async setAllBranch({ commit, state }, force) {
      if (
        (!state.allBranch.length || force === true) &&
        !loadings.commit_all_branch
      ) {
        const tenantId = sessionStorage.getItem("tenantId") || 1;
        loadings.commit_all_branch = await queryAllOrgan({ tenantId });
        try {
          const res = await loadings.commit_all_branch;
          const result = res.data;
          let tempOrgan = [];
          // 过滤不会显示的分部
          result.forEach((item) => {
            if (!filterOrganId.includes(item.key)) {
              tempOrgan.push(item);
            }
          });
          commit("commit_all_branch", tempOrgan);
        } catch (error) {
          //
        }
        loadings.commit_all_branch = false;
      }
    },
  },
});
